'v16a
'disabled plugin message processing
'start server automatically
'tries to play server after unpack even if it works or fails. so server always tries to start.


Function httpServer_Initialize(msgPort As Object, userVariables As Object, bsp as Object)

    print "httpServer_Initialize - entry"
    
	httpServer = newhttpServer(msgPort, userVariables, bsp)
	
	return httpServer

End Function



Function newhttpServer(msgPort As Object, userVariables As Object, bsp as Object)
	print "httpserver Plugin Object Created"

	'
	dl = createobject("roSystemLog")

	' Create the object to return and set it up
	s = {}
	s.msgPort = msgPort
	s.userVariables = userVariables
	s.bsp = bsp
	s.ProcessEvent = httpServer_ProcessEvent
	s.startserver = httpserver_startserver
	s.deltree = httpServer_deltree
	s.sendmessage = httpServer_sendMessage
	s.handlejsevent = httpServer_HandleJSEvent
	s.sTime = CreateObject("roSystemTime")
	s.objectName = "httpServer_object"
	s.serveroff = true
	
	's.StartTimer()

		if GetFiles(bsp) and Canwestart() then
			pkg = createobject("roBrightPackage", "sd:/npm.zip")
			dl.sendline("@@@@@@@@@@ "+pkg.getfailurereason())
			createdirectory("sd:/node")
			's.deltree("/node")
	
			if pkg <> invalid then 
				pkg.unpack("/node")
				dl.sendline("@@@@@@@@@@Unpacked to node")
				Deletefile("npm.zip")
			else
				dl.sendline("@@@@@@@@@@Pkg invalid")			
			endif
		endif
		s.startserver()


	return s
	
End Function



Function httpServer_ProcessEvent(event As Object) as boolean
	

	retval = false
    print "httpserver_ProcessEvent - entry"
    print "type of m is ";type(m)
    print "type of event is ";type(event)
		

	'if m.serveroff then
	'	m.serveroff = false
	'	m.startserver()
	'endif


	if type(event) = "roHtmlWidgetEvent" then
		m.HandleJSEvent(event)
	
	else if type(event) = "roAssociativeArray" then		
		if type(event["EventType"]) = "roString"
		
		et$=event["EventType"]
		print "event type is" ;et$
			if event["EventType"] = "EVENT_PLUGIN_MESSAGE" then
			    
			    print "BRKARK_httpServer_event_plugin_message"
				if event["PluginName"] = "httpServer" then
					pluginMessage$ = event["PluginMessage"]
					print "BRKARK plugin message"		
					retval = m.HandlePluginMessageEvent(pluginMessage$)					
				end if
			
			else if event["EventType"] = "SEND_PLUGIN_MESSAGE" then
			     print "BRKARK2_httpServer_event_plugin_message"
				if event["PluginName"] = "httpServer" then
					pluginMessage$ = event["PluginMessage"]
				    print "BRKARK2 plugin message"
					'retval = m.HandlePluginMessageEvent(pluginMessage$)					
				end if				
			end if
		end if
	end if

	return retval

End Function



Sub httpServer_StartServer()
retval=false
	
		print " httpserver pluginMessage$ event received ||||| "; pluginMessage$
		
		 rs = createobject("roregistrysection", "html")
				mp = rs.read("mp")
				if mp <> "1" then
					rs.write("mp","1")
					rs.flush()
					RebootSystem()	'reboots player first time it's changed
				endif


				r = CreateObject("roRectangle", 0,0,1920,1080)

				config = {
				  nodejs_enabled: true
				  security_params: {
					websecurity: false
				  }

				  'user_stylesheet: "sd:/autorun.css"
				  'url: "file:///sd:index.html"
				  url: "file:///sd:/node/server.html"
				  brightsign_js_objects_enabled: true
				  javascript_enabled: true
				  hwz_default: "on"
				  inspector_server: {
					port: 3000
				  }

				  mouse_enabled: true
				  focus_enabled: true
				  storage_path: "sd:/db"      
				  storage_quota: 10048576
				}

				m.htmlWidget = CreateObject("roHtmlWidget", r, config)
				m.htmlWidget.SetPort(m.msgport)
				m.htmlWidget.show()

End Sub


Function GetFiles(pr as object) as Boolean
	slog = createobject("roSystemLog")
	slog.sendline("getfiles helper")
'2

runpath$=""
runpath$ = GetPoolFilePath(pr.assetPoolFiles, "npm.zip")

	if runpath$ <> "" then 
		okrun = Copyfile(runpath$, "npm.zip")
		print "copied autorun: ";okrun
		if okrun then Deletefile(runpath$)

		if okrun then
			return true
		else
			return false
		endif

	else
		slog.sendline("One or more files didn't return a pool path")
		print "autorun found: ";okrun
	endif
	

	return false
	
end Function



Function Canwestart() as boolean
	slog = createobject("roSystemLog")
	slog.sendline("canwestart helper")

	auto = false
	mylist = matchfiles(".","*.zip")

	For each file in mylist
		print file
		If file ="npm.zip" then auto = true
		'if auto then Deletefile("npm.zip") 'new, from Julian
	Next
	
	print "auto: ";auto
	
	If auto then
		return true
	else
		return false
	endif

End Function


Sub httpServer_deltree(path$ as string)

        mylistb = listdir(path$)
        
        For each item in mylistb
            if instr(1, item, ".") > 0 then 
                DeleteFile(path$+"/"+item)
            else
                if len(item) > 1 then
                    DeleteFile(path$+"/"+item)    'folders only 1 digit long outside root
                else
                    m.deltree(path$+"/"+item)
                endif
            endif
        next

end Sub


Sub httpServer_HandleJSEvent(origMsg as Object)

		jsm = origMsg.GetData()
		print jsm
		print "printing reason: "; jsm.reason
		
		if jsm.reason = "message" then
			print jsm.message
			
			if jsm.message.zonemessage <> invalid then
				command$ = jsm.message.zonemessage
				m.sendmessage(command$)
				if (m.userVariables["zonemessage"] <> invalid) then
					m.userVariables["zonemessage"].SetCurrentValue(command$, true)
				end if	
			else
				m.bsp.diagnostics.printdebug("@@@zonemessage not found / postmessage should be ")	
			endif
		else
			print "NO Message in js object"
		endif
		

End Sub


sub httpServer_sendMessage(message$ as string) 
'send zone message
		sendZoneMessageParameter$ = message$
		zoneMessageCmd = CreateObject("roAssociativeArray")
		zoneMessageCmd["EventType"] = "SEND_ZONE_MESSAGE"
		zoneMessageCmd["EventParameter"] = sendZoneMessageParameter$
		m.msgPort.PostMessage(zoneMessageCmd)

end sub



